/**
 * CMI : Cluster Method Invocation
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: carol@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * --------------------------------------------------------------------------
 * $Id: Config.java 1995 2008-08-05 09:24:56Z loris $
 * --------------------------------------------------------------------------
 */

package org.ow2.cmi.controller.server.impl.jms;


/**
 * @author Loris Bouzonnet
 *
 */
public final class Config extends org.ow2.cmi.controller.server.Config {

    private String superTopicName;

    private String superProviderURL;

    private String ourTopicName;

    private String ourProviderURL;

    private boolean publisher = true;

    private String jmsProviderName = "jms_provider";

    private String connectionFactoryName = "JTCF";

    private String clusterViewProviderURL;

    private boolean clusterViewShared = true;

    private String objectNameToListen;

    private long periodToBeat = 60000;

    private long periodToCleanUp = 120000;

    private int waitingBeatNumber = 4;


    public String getJmsProviderName() {
        return jmsProviderName;
    }

    public void setJmsProviderName(final String jmsProviderName) {
        this.jmsProviderName = jmsProviderName;
    }

    public String getOurProviderURL() {
        return ourProviderURL;
    }

    public void setOurProviderURL(final String ourProviderURL) {
        this.ourProviderURL = ourProviderURL;
    }

    public String getSuperProviderURL() {
        return superProviderURL;
    }

    public void setSuperProviderURL(final String providerURL) {
        this.superProviderURL = providerURL;
    }

    public String getSuperTopicName() {
        return superTopicName;
    }

    public void setSuperTopicName(final String superTopicName) {
        this.superTopicName = superTopicName;
    }

    public String getOurTopicName() {
        return ourTopicName;
    }

    public void setOurTopicName(final String ourTopicName) {
        this.ourTopicName = ourTopicName;
    }

    public boolean isPublisher() {
        return publisher;
    }

    public void setPublisher(final boolean publisher) {
        this.publisher = publisher;
    }

    public String getConnectionFactoryName() {
        return connectionFactoryName;
    }

    public void setConnectionFactoryName(final String connectionFactoryName) {
        this.connectionFactoryName = connectionFactoryName;
    }

    public String getClusterViewProviderURL() {
        return clusterViewProviderURL;
    }

    public void setClusterViewProviderURL(final String clusterViewProviderURL) {
        this.clusterViewProviderURL = clusterViewProviderURL;
    }

    public boolean isClusterViewShared() {
        return clusterViewShared ;
    }

    public void setClusterViewShared(final boolean clusterViewShared) {
        this.clusterViewShared = clusterViewShared;
    }

    public String getObjectNameToListen() {
        return objectNameToListen;
    }

    public void setObjectNameToListen(final String objectNameToListen) {
        this.objectNameToListen = objectNameToListen;
    }

    public long getPeriodToBeat() {
        return periodToBeat;
    }

    public void setPeriodToBeat(final long periodToBeat) {
        this.periodToBeat = periodToBeat;
    }

    public void setPeriodToCleanUp(final long periodToCleanUp) {
        this.periodToCleanUp = periodToCleanUp;
    }

    public void setWaitingBeatNumber(final int waitingBeatNumber) {
        this.waitingBeatNumber = waitingBeatNumber;
    }

    public long getPeriodToCleanUp() {
        return periodToCleanUp;
    }

    public int getWaitingBeatNumber() {
        return waitingBeatNumber;
    }

}
