/**
 * CMI : Cluster Method Invocation
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: carol@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * --------------------------------------------------------------------------
 * $Id: JORAMHelper.java 1965 2008-07-29 15:40:02Z loris $
 * --------------------------------------------------------------------------
 */

package org.ow2.cmi.controller.server.impl.jms;

import java.net.ConnectException;

import javax.jms.Topic;

import org.objectweb.joram.client.jms.admin.AdminException;
import org.objectweb.joram.client.jms.admin.AdminModule;
import org.ow2.util.log.Log;
import org.ow2.util.log.LogFactory;

/**
 * @author Loris Bouzonnet
 */
public final class JORAMHelper {

    /**
     * Logger.
     */
    private static final Log logger = LogFactory.getLog(JORAMHelper.class);

    public static Topic createTopic(final String topicName, final Topic superTopic)
    throws ConnectException, AdminException {
        org.objectweb.joram.client.jms.Topic topic = org.objectweb.joram.client.jms.Topic.create(topicName);
        topic.setFreeReading();
        topic.setFreeWriting();
        if(superTopic != null && superTopic instanceof org.objectweb.joram.client.jms.Topic) {
            if(AdminModule.getDomainNames(AdminModule.getLocalServerId()).length != 0) {
                topic.setParent(
                        (org.objectweb.joram.client.jms.Topic) superTopic);
            } else {
                logger.warn("Unable to use a hierarchical topic: check your configuration of JORAM!");
            }
        }
        return topic;
    }

}
